<?php
/********************************************************************************
 * #                      Advanced File Manager v3.0.3
 * #******************************************************************************
 * #      Author:     CriticalGears
 * #      Email:      info@criticalgears.com
 * #      Website:    http://www.criticalgears.io
 * #
 * #
 * #      Version:    3.0.3
 * #      Copyright:  (c) 2009 - 2020 - Criticalgears.io
 * #
 * #*******************************************************************************/
session_start();
require_once("includes/dbconnect.php"); //Load the settings
require_once("includes/functions.php"); //Load the functions
$msg = "";
//LOGIN VARIABLES
$username = (!empty($_REQUEST['username'])) ? strip_tags(str_replace("'", "`", $_REQUEST['username'])) : '';
$password = (!empty($_REQUEST['password'])) ? strip_tags(str_replace("'", "`", $_REQUEST['password'])) : '';
$g_recaptcha_response = isset( $_POST['g-recaptcha-response'] ) ? strip_tags(str_replace("'", "`", $_REQUEST['g-recaptcha-response'])) : '';
// LOGIN

$has_recaptcha = !empty(getSettings('recaptcha_secret')) && !empty(getSettings('recaptcha_key'))?true:false;
// LOGIN
if (!empty($_REQUEST["login"]) && $_REQUEST['login'] == "yes") {
    // Validate recaptcha
	// Validate recaptcha
	$captcha_valid = true;
	if (isset($_SESSION['captcha']) & $has_recaptcha ) {
		$ch = curl_init();
		curl_setopt_array($ch, [
			CURLOPT_URL => 'https://www.google.com/recaptcha/api/siteverify',
			CURLOPT_POST => true,
			CURLOPT_POSTFIELDS => [
				'secret' => getSettings('recaptcha_secret'),
				'response' => $g_recaptcha_response,
				'remoteip' => $_SERVER['REMOTE_ADDR']
			],
			CURLOPT_RETURNTRANSFER => true
		]);
		$output = curl_exec($ch);
		curl_close($ch);

		$response = json_decode($output, true);
		if ( $response["success"] === true ) {
			$captcha_valid = true;
		} else {
			$captcha_valid = false;
		}
	}
    if (isset($_SESSION['reqCaptcha']) && $_SESSION['reqCaptcha'] == true and $captcha_valid == false) {
        $msg .= " Invalid captcha";
    } else {
        if ($username == "" || $password == "") {
            $_SESSION['reqCaptcha'] = true;
            $msg                    = $msg . "Empty username and/or password";
        } else {
            $sSQL = "SELECT * FROM `{$db_pr}users` WHERE `username`='" . $username . "' AND active='1'";
            $result = mysqli_query($mysqli,$sSQL) or die("Invalid query: " . mysqli_error($mysqli));
            if (mysqli_num_rows($result) > 0) {
                $row = mysqli_fetch_assoc($result);
                if (md5($password) != $row["password"]) {
                    $_SESSION['reqCaptcha'] = true;
                    $msg                    = $msg . "Wrong username and/or password";
                    addLog($row["id"], "Error during login. Wrong password.");
                } else {
                    if ((isset($_SESSION['captcha']) and $captcha_valid == true) or (!isset($_SESSION['captcha']))) {
                        $_SESSION['idUser']      = $row["id"];
                        $_SESSION['username']    = $row["username"];
                        $_SESSION['accesslevel'] = $row["accesslevel"];
                        $_SESSION['logged_in']   = true;
                        $sSQL                    = "UPDATE `{$db_pr}users` SET `last_login`=NOW() WHERE `id`='" . $row["id"] . "'";
                        mysqli_query($mysqli,$sSQL) or die("Invalid query: " . mysqli_error($mysqli));
                        addLog($row["id"], "Successfully logged in.");
                    }
                }
            } else {
                $_SESSION['reqCaptcha'] = true;
                $msg                    = $msg . " Wrong username (username) and/or password.";
            }
        }
    }
}
if (isset($_SESSION["logged_in"]) && $_SESSION["logged_in"] == true) {
    header("Location: main.php");
    exit();
} else {
include "includes/header_static.php";
    ?>
    <script src="https://www.google.com/recaptcha/api.js" async defer></script>
<div class="contentPage">
    <h1 class="header">Advanced File Management 3</h1>

    <div class="loginForm">
        <?php if ($msg != '') { ?>
            <div class="loginMessage loginError"> <?php echo $msg; ?></div>
        <?php } ?>

        <form class="form-horizontal" role="form" name="ff1" method="post">
            <input type="hidden" name="login" value="yes"/>
            <div class="form-group">
                <label for="inputEmail3" class="sr-only">Username</label>
                <div class="col-sm-12">
                    <input type="text" class="form-control" id="inputEmail3" placeholder="Username" name="username" value="<?php echo $username ?>" tabindex="1">
                </div>
            </div>
            <div class="form-group">
                <label for="inputPassword3" class="sr-only">Password</label>
                <div class="col-sm-12">
                    <input type="password" class="form-control" id="inputPassword3" placeholder="Password" name="password" tabindex="2">
                </div>
            </div>
	        <?php if (isset($_SESSION['reqCaptcha']) && $has_recaptcha) { ?>

                <div class="g-recaptcha" data-sitekey="<?php echo getSettings('recaptcha_key')?>" data-callback="captchaOk"></div>

	        <?php } ?>
            <div class="form-group">
                <div class="col-sm-6">
                    <?php
                    $allow_reg = getReg();
                    if ($allow_reg) { ?>
                        <a href="user_registration.php">create account</a>
                    <?php } ?>
                </div>
                <div class="col-sm-6 text-right">
                    <a href="forgot_password.php">forgot password?</a>
                </div>
            </div>
            <div class="form-group">
                <div class="col-sm-12">
                    <button type="submit" class="btn btn-primary btn-lg btn-block"  id="submit_button"
	                        <?php if (isset($_SESSION['reqCaptcha']) && $has_recaptcha) { ?>disabled<?php }?>>Sign in</button>
                </div>
            </div>
        </form>
    </div>
    <script>
        function captchaOk(){
            $("#submit_button").prop('disabled',false)
        }
    </script>
    <?php include "includes/footer.php";
} ?>