<?php
/**
 * Plugin Name: fawaz Call Buttons
 * Description: إضافة زر الاتصال على الهاتف المحمول, وضع ارقام مخصصة للمقالات والصفحات.
 * Version: 1.0.2
 * Author: fawaz
 * Author URI: https://www.fawazz99.com/
 */

define('MEMO_CALL_BUTTON_VERSION', '1.0.2');

function add_custom_call_meta(){
    $post_types = array ( 'post', 'page' );
    add_meta_box(
    'ms-meta-phone',
    'زر الإتصال',
    'add_ms_call_meta_fields',
    $post_types,
    "side", 
    "high"
);
}
add_action("add_meta_boxes", "add_custom_call_meta");

function add_ms_call_meta_fields($post){
    wp_nonce_field( '_ms_meta_phone_nonce', 'ms_meta_phone_nonce' );
    $diwp_textfield = get_post_meta( $post->ID, '_ms_call_field', true);
    $diwp_textareafield = get_post_meta( $post->ID, '_ms_whats_field', true);
    $ms_call_status = get_post_meta( $post->ID, '_ms_call_status', true);
    $ms_whats_status = get_post_meta( $post->ID, '_ms_whats_status', true);
    $ms_whats_txt = get_post_meta($post->ID, '_ms_whats_single_txt', true);
    ?>
  
    
    <div class="row">
    <div class="fields">
        <br>
        <input type="checkbox" name="_ms_call_status" value="<?= $ms_call_status ?>" id="ms-call-status" <?php if($ms_call_status === '1') echo 'checked'; ?> /> 
        <label for="ms-call-status">اخفاء زر الاتصال</label>
         <br>
         <br>
        <label for="ms-call-field">الهاتف :</label>
        <input type="text" name="_ms_call_field" id="ms-call-field" value="<?= $diwp_textfield; ?>">
    </div>
    <br>
    <div class="fields">  
        <br>
        <input type="checkbox" name="_ms_whats_status" value="<?= $ms_whats_status ?>" id="ms-whats-status" <?php if($ms_whats_status === '1') echo 'checked'; ?>  /> 
        <label for="ms-whats-status">اخفاء زر الواتس</label>
         <br>
         <br>
        <label for="ms-whats-field">واتس :</label>
        <input type="text" name="_ms_whats_field" id="ms-whats-field" value="<?= $diwp_textareafield; ?>">
        <br>
        <div class="fields" style="border-top: 1px solid #eee;">
            <br>
            <label for="ms-whats-single-txt">نص رسالة الواتس :</label>
            <br>
            <br>
            <textarea name="_ms_whats_single_txt" class="widefat" style=" min-height:80px !important;" id="ms-whats-single-txt"><?= $ms_whats_txt; ?></textarea>

        </div>
    </div>
</div>
<?php }

function save_ms_phone_meta_box( $post_id ) {
    if ( ! isset( $_POST['ms_meta_phone_nonce'] ) || ! wp_verify_nonce( $_POST['ms_meta_phone_nonce'], '_ms_meta_phone_nonce' ) ) return;
 
    if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) return;

    if ( ! current_user_can( 'edit_post', $post_id ) ) return;

    if(isset($_POST["_ms_call_field"])) :
    update_post_meta($post_id, '_ms_call_field', $_POST["_ms_call_field"]);
    endif;
    
    $call_status = isset($_POST['_ms_call_status']) ? '1' : '0';
    update_post_meta($post_id, '_ms_call_status', $call_status);

    $call_status = isset($_POST['_ms_whats_status']) ? '1' : '0';
    update_post_meta($post_id, '_ms_whats_status', $call_status);

    if(isset($_POST["_ms_whats_field"])) :
    update_post_meta($post_id, '_ms_whats_field', $_POST["_ms_whats_field"]);
    endif;
    if (isset($_POST["_ms_whats_single_txt"])) :
        update_post_meta($post_id, '_ms_whats_single_txt', $_POST["_ms_whats_single_txt"]);
    endif;
 
}
add_action("save_post", "save_ms_phone_meta_box");


class MS_Custom_Call_Button {

    private $plugin_path;
    private $plugin_url;

    public function __construct() {

        // admin
        add_action( 'admin_menu',[ $this, 'ms_add_menu' ] );

        // create needed initialization
        add_action('admin_init', [  $this, 'ms_register_options_settings'] );

        // add custom call button
        add_action('wp_footer', [ $this, 'ms_add_buttons'], 10);

        // grab the options, use for entire object
        $this->ms_options = $this->ms_options();

        add_action('wp_head', [  $this, 'ms_call_button'], 100);

    }

    public function ms_add_menu(){
             add_options_page('إعدادات زر الإتصال', 'زر الإتصال', 'publish_posts', 'ms_custom_call_button', [ $this,'ms_options_page']); 
    }

   public function ms_call_button(){

     echo '<style>
     .txt-center{
      text-align: center;
     }
    .txt-center ul li{
      list-style: none
    }
    .clear:after,
    .clear:before {
        content: " ";
        display: table;
        table-layout: fixed
    }

    .clear:after {
        clear: both
    }
    .ms-whats-button,
    .ms-call-button {
        display: flex;
        position: fixed;
        bottom: 0.3em;
        left: 6px;
        outline: 0;
        cursor: pointer;
        z-index: 9999;
        text-decoration: none;
    }
    .ms-call-button{
       bottom: 5.2em;
    }
    
    .ms-call-icon{
        display: inline-block;
        position: relative;
        width: 60px;
        height: 60px;
        text-align: center;
        border-radius: 50%;
        background-color: #d83f91;
        box-shadow: 1px 1px 6px 0px rgba(68, 68, 68, 0.705);
        animation: call-rotate 2s infinite ease-in-out;
    }
  .ms-whats-txt,
  .ms-call-txt{
        padding: 0 22px 0 33px;
        font-size: 15px;
        font-weight: 600;
        display: inline-block;
        background: #d83f91;
        color: #fff;
        margin-left: -17px;
        line-height: 40px;
        border-radius: 10px;
        height: 42px;
        box-shadow: 0 0 5px rgb(0 0 0 / 10%);
        margin-top: 10px;
        text-align: center;
  }
  .ms-whats-button .ms-call-icon{
    background: #009c50;
}
  .ms-whats-txt{
    padding: 0 31px 0 35px;
    background: #009c50;
  }
  .ms-call-txt{
  }
    .ms-call-button.active .ms-call-txt,
    .ms-whats-button.active .ms-whats-txt,
    .ms-call-button:hover .ms-call-txt,
    .ms-whats-button:hover .ms-whats-txt{
        -webkit-box-shadow: 0 8px 16px 0 rgba(0, 0, 0, .2), 0 6px 20px 0 rgba(0, 0, 0, .19);
        box-shadow: 0 8px 16px 0 rgba(0, 0, 0, .2), 0 6px 20px 0 rgba(0, 0, 0, .19)
    }
    @keyframes call-rotate {
        0%, 100%, 50% {
            -webkit-transform: rotate(0) scale(1) skew(1deg);
            transform: rotate(0) scale(1) skew(1deg)
        }
        10%, 30% {
            -webkit-transform: rotate(-25deg) scale(1) skew(1deg);
            transform: rotate(-25deg) scale(1) skew(1deg)
        }
        20%, 40% {
            -webkit-transform: rotate(25deg) scale(1) skew(1deg);
            transform: rotate(25deg) scale(1) skew(1deg)
        }
    }
 </style>';

    }
    function ms_options_page(){

        if ( !(isset($_GET['page']) && $_GET['page'] == 'ms_custom_call_button' )) 
            return;
         ?>
    
        <div class='wrap'>
            <h1>إعدادات زر الاتصال</h1>
         <form method="post" action="options.php" class="form-table">
            <?php
            wp_nonce_field('ms_options');
            settings_fields('ms_custom_options-group');
            ?>
            <table border=0 cellpadding=2 cellspacing="2">
                <tr>
                    <th>حالة الزر</th>
                    <td class="activated">
                    <input id="activated" name="ms_options[active]" type="checkbox" value="1" <?php checked('1', $this->ms_options['active']); ?> /> 
                    <label title="Enable" for="activated"><?php if($this->ms_options['active'] > 0 ) echo 'مفعل'; else echo 'تفعيل';?></label> &nbsp; &nbsp; 
                     </td>
                </tr> 
            </table>

            <table border=0 cellpadding=2 cellspacing="2">
            <tr>
                <th>الرقم الاساسي</th>
                <td>
                    <input name="ms_options[phone_number]" placeholder="" value='<?= $this->ms_sanitize_phone($this->ms_options['phone_number']); ?>' /><br />
                </td>
            </tr>

            </table>            

            <p class="submit">
                <input type="submit" class="button-primary" value="حفظ الاعدادات" />
            </p>

            </form>  
             <hr>
             <div class="donate" style="text-align: center;">
                    <strong><a href="https://www.fawaz.agency/">برمجة بواسطة فواز</a></strong>
                    <p for="quick-call-button-shake-effect">الاصدار <?= MEMO_CALL_BUTTON_VERSION; ?> </p>
            </div>   
             <hr>                    
        </div>
        
        <?php

    }


     function ms_register_options_settings() { 
        register_setting( 'ms_custom_options-group', 'ms_options' );
    }  



    function ms_options() { 
       
        $defaults = array(
            'active' => '0',
            'phone_number'  => '',
        );

        // Get user options
        $ms_options = get_option('ms_options');     
        
        // if the user hasn't made settings yet, default
        if (is_array($ms_options)) {
            // Lets make sure we have a value for each as some might be new.
            foreach ($defaults as $k => $v)
                if (!isset($ms_options[$k]) || empty($ms_options[$k]))
                    $ms_options[$k] = $v;
        }else { // Must be first, lets use defaults
            $ms_options = $defaults;
        }
        
        return $ms_options;
    }

    function get_meta_phone(){
        global $wp_query;
        
        $post_id = $wp_query->get_queried_object_id();

        $me_phone_meta =  get_post_meta($post_id, "ms-meta-phone", true);

        if ( !empty($me_phone_meta) )  {

             return $this->ms_sanitize_phone($me_phone_meta);

        }else{
            
            return $this->ms_sanitize_phone($this->ms_options['phone_number']);
        
        }

    }
    function ms_sanitize_phone($number) {

        return filter_var($number, FILTER_SANITIZE_NUMBER_INT);
    }


    function ms_mandatory_have_info() {
        return (($this->ms_options['active'] > 0 ) ) ? true : false;
    }

    function ms_add_buttons() {
        
        if(is_feed()){

            return;
        }

        global $wp_query;

        $return =  "\n\n";

        $post_id = $wp_query->get_queried_object_id();

        $me_phone_meta =  get_post_meta( $post_id, '_ms_call_field', true); 
        $me_phone_meta = (empty($me_phone_meta)) ? $this->ms_options['phone_number'] : $me_phone_meta ;
        $me_whats_meta =  get_post_meta( $post_id, '_ms_whats_field', true);
        $me_whats_meta = (empty($me_whats_meta)) ? $this->ms_options['phone_number'] : $me_whats_meta ;
        $mswhats_single_txt =  get_post_meta($post_id, '_ms_whats_single_txt', true);

        $call_status = get_post_meta( $post_id, '_ms_call_status', true);
        $whats_status = get_post_meta( $post_id, '_ms_whats_status', true);


        $ms_whats_pst_title = 'https://wa.me/+966'.$me_whats_meta.'' ;

        


        if ($this->ms_mandatory_have_info()) {
            
            $return .=  '<div class="clear">';


            if ( $call_status !== '1' ) { 
                $return .= '
                    <a href="tel:0'.$me_phone_meta.'" class="ms-call-button">
                        <span class="ms-call-txt" >إتصل الآن</span>
                        <span class="ms-call-icon" aria-hidden="true">
                            <svg version="1.1" xmlns="http://www.w3.org/2000/svg" width="35" height="60" viewBox="0 0 512 512" style="fill:#fff;">
                             <path d="M352 320c-32 32-32 64-64 64s-64-32-96-64-64-64-64-96 32-32 64-64-64-128-96-128-96 96-96 96c0 64 65.75 193.75 128 256s192 128 256 128c0 0 96-64 96-96s-96-128-128-96z"></path>
                            </svg>
                        </span>
                    </a>';

            }

            if ( $whats_status !== '1' ) { 
                $return .= '<a href="'.$ms_whats_pst_title.'" class="ms-whats-button" target="_blank" rel="noopener noreferrer">
                        <span class="ms-whats-txt" >واتساب</span>
                        <span class="ms-call-icon" aria-hidden="true">
                            <svg version="1.1" xmlns="http://www.w3.org/2000/svg" width="45" height="55" viewBox="0 0 24 24" style="fill:#fff;"><path d="M.057 24l1.687-6.163c-1.041-1.804-1.588-3.849-1.587-5.946.003-6.556 5.338-11.891 11.893-11.891 3.181.001 6.167 1.24 8.413 3.488 2.245 2.248 3.481 5.236 3.48 8.414-.003 6.557-5.338 11.892-11.893 11.892-1.99-.001-3.951-.5-5.688-1.448l-6.305 1.654zm6.597-3.807c1.676.995 3.276 1.591 5.392 1.592 5.448 0 9.886-4.434 9.889-9.885.002-5.462-4.415-9.89-9.881-9.892-5.452 0-9.887 4.434-9.889 9.884-.001 2.225.651 3.891 1.746 5.634l-.999 3.648 3.742-.981zm11.387-5.464c-.074-.124-.272-.198-.57-.347-.297-.149-1.758-.868-2.031-.967-.272-.099-.47-.149-.669.149-.198.297-.768.967-.941 1.165-.173.198-.347.223-.644.074-.297-.149-1.255-.462-2.39-1.475-.883-.788-1.48-1.761-1.653-2.059-.173-.297-.018-.458.13-.606.134-.133.297-.347.446-.521.151-.172.2-.296.3-.495.099-.198.05-.372-.025-.521-.075-.148-.669-1.611-.916-2.206-.242-.579-.487-.501-.669-.51l-.57-.01c-.198 0-.52.074-.792.372s-1.04 1.016-1.04 2.479 1.065 2.876 1.213 3.074c.149.198 2.095 3.2 5.076 4.487.709.306 1.263.489 1.694.626.712.226 1.36.194 1.872.118.571-.085 1.758-.719 2.006-1.413.248-.695.248-1.29.173-1.414z">
                            </path>
                            </svg>
                        </span>
                    </a>'; 

            }
    

            $return .= "</div>";



        } 
        $return .= "\n\n";
            
        echo $return;
    }

  
}

new MS_Custom_Call_Button();