<?
class ActorsDB {
	function __construct() {
		global $wpdb;
		$this->wpdb = $wpdb;
		$this->actorsrows_dbversion = '1.0';
		$this->table_name = 'CastsInfo';
	}
	public function create() {
		global $wpdb;
		$charset_collate = $wpdb->get_charset_collate();
		$table_name = $this->table_name;

		$sql = "CREATE TABLE $table_name (
			option_id bigint(20) NOT NULL AUTO_INCREMENT,
			postID varchar(191) NOT NULL,
			cast longtext NOT NULL,
			PRIMARY KEY  (option_id)
		) $charset_collate;";

		require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
		dbDelta( $sql );

		update_option( 'actorsrows_version', $this->actorsrows_dbversion );
	}
	public function get( $postID ) {
	 	global $wpdb;
	 	$table_name = $this->table_name;
	 	$row = $wpdb->get_row(
	 		$wpdb->prepare( "SELECT DISTINCT cast FROM $table_name WHERE postID = %s LIMIT 1", $postID )
	 	);
	 	if( !$row ) {
	 		return false;
	 	}else {
	 		$cast = maybe_unserialize($row->cast);
	 	}
		return $cast;
	}
	public function add( $postID, $cast = '' ) {
	 	global $wpdb;
		$result = $wpdb->insert(
			$this->table_name,
			array(
			    'postID' => $postID,
			    'cast' => $cast,
			)
		);
		if( !$result ) {
			return false;
		}
		return true;
	}
	public function update( $postID, $cast ) {
	 	global $wpdb;
		$Context = new ThemeContext();
	 	$table_name = $this->table_name;
	 	// Value Serialize
	 	$cast = maybe_serialize($cast);

	 	// Update or Add
	    $update = $wpdb->get_row(
	 		$wpdb->prepare( "SELECT cast FROM $table_name WHERE postID = %s LIMIT 1", $postID )
	 	);
	 	if( $update ) {
	 		$result = $wpdb->update($table_name, array('cast'=>$cast), array('postID'=>$postID));
	 		if( !$result ){
	 			return false;
	 		}
		}else {
		    $this->add($postID, $cast);
		}
		return true;
	}
	public function check() {
	    if ( get_site_option( 'actorsrows_version' ) != $this->actorsrows_dbversion ) {
	        $this->create();
	    }
	}
}