<?
class FriendsDB {
	function __construct() {
		global $wpdb;
		$this->wpdb = $wpdb;
		$this->Friends_dbversion = '1.1';
		$this->table_name = 'Friends';
	}
	public function create() {
		global $wpdb;
		$charset_collate = $wpdb->get_charset_collate();
		$table_name = $this->table_name;

		$sql = "CREATE TABLE $table_name (
			id bigint(20) NOT NULL AUTO_INCREMENT,
			sender longtext NOT NULL,
			reciever longtext NOT NULL,
			points longtext NOT NULL,
			globe_points longtext NOT NULL,
			date longtext NOT NULL,
			PRIMARY KEY  (id)
		) $charset_collate;";

		require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
		dbDelta( $sql );

		update_option( 'Friends_version', $this->Friends_dbversion );
	}
	public function check() {
	    if ( get_site_option( 'Friends_version' ) != $this->Friends_dbversion ) {
	        $this->create();
	    }
	}
	public function get( $where=array() ) {
	 	global $wpdb;
	 	$table_name = $this->table_name;
	 	$Operator = "SELECT * FROM `$table_name`";
	 	if( !empty($where) ) {
	 		$Operator .= " WHERE ";
	 		$k = 0;
		 	foreach ($where as $key => $value) {$k++;
		 		if( $k > 1	 ) {
		 			$Operator .= ' AND ';
		 		}
		 		if( is_numeric($value) ) {
			 		$Operator .= "`$key` = $value";
		 		}else {
			 		$Operator .= "`$key` = '$value'";
		 		}
		 	}
		 }
	 	$f = $wpdb->get_row($Operator);
	 	//
	 	return $f;
	}
	public function isOnline( $user ) {
		if( isset($user->last_activity) ) {
			//echo $user->last_activity;
			$dateorig = date('d-m-Y H:i:s', $user->last_activity);
			$date = date('d-m-Y H:i:s', strtotime($dateorig.' +1 minutes'));
			//
			if( time() <= strtotime($date) ) {
				$status = true;
			}else {
				$status = false;
			}
		}else {
			$status = true;
		}
		return $status;
	}
	public function isFriends( $id1, $id2 ) {
	 	global $wpdb;
	 	$table_name = $this->table_name;
	 	$Operator = "SELECT * FROM `$table_name` WHERE `sender` = '$id1' AND `reciever` = '$id2' or `sender` = '$id2' AND `reciever` = '$id1'";
	 	$f = $wpdb->get_row($Operator);
	 	//
	 	return $f;
	}
	public function FriendsList($offset=0, $per=80, $search=false) {
	 	global $wpdb, $current_user;
	 	$userID = $current_user->ID;
	 	$table_name = $this->table_name;
 		$Operator = "SELECT * FROM `$table_name` WHERE `sender` = '$userID' or `reciever` = '$userID' ORDER BY CAST(points AS int) DESC LIMIT $offset, $per";
	 	$f = $wpdb->get_results($Operator);
	 	//
	 	return $f;
	}
	public function delete( $where=array() ) {
	 	global $wpdb;
	 	$table_name = $this->table_name;

 		$wpdb->delete($table_name, $where);
	}
	public function update( $info=array(), $where=array() ) {
	 	global $wpdb;
	 	$table_name = $this->table_name;
		$result = $wpdb->update(
			$this->table_name,
			$info,
			$where
		);
		if( !$result ) {
			return false;
		}
		return true;
	}
	public function add( $info=array() ) {
	 	global $wpdb;
	 	if( !isset($info['points']) ) $info['points'] = 0;
	 	if( !isset($info['globe_points']) ) $info['globe_points'] = 0;
	 	if( $info['sender'] == $info['reciever'] ) return false;
	 	$info['date'] = time();
	 	$table_name = $this->table_name;
		$result = $wpdb->insert(
			$this->table_name,
			$info
		);
		if( !$result ) {
			return false;
		}
		return true;
	}
}
add_action("after_switch_theme", array((new FriendsDB), "create"));
add_action( 'plugins_loaded', array((new FriendsDB), "check") );