<?
class PeopleInfoDB {
	function __construct() {
		global $wpdb;
		$this->wpdb = $wpdb;
		$this->PeopleInfo_dbversion = '1.0';
		$this->table_name = 'PeopleInfo';
	}
	public function create() {
		global $wpdb;
		$charset_collate = $wpdb->get_charset_collate();
		$table_name = $this->table_name;

		$sql = "CREATE TABLE $table_name (
			id bigint(20) NOT NULL AUTO_INCREMENT,
			name longtext NOT NULL,
			info longtext NOT NULL,
			PRIMARY KEY  (id)
		) $charset_collate;";

		require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
		dbDelta( $sql );

		update_option( 'PeopleInfo_version', $this->PeopleInfo_dbversion );
	}
	public function get( $id ) {
	 	global $wpdb;
	 	$table_name = $this->table_name;
	 	$rows = $wpdb->get_row(
	 		"SELECT DISTINCT info FROM $table_name WHERE id = $id"
	 	);
	 	if( isset($rows->info) ) {
	 		$rows->info = maybe_unserialize(unserialize(stripslashes($rows->info)));
	 	}
		return (ARRAY) $rows->info;
	}
	public function add( $info ) {
	 	global $wpdb;
	 	$info['info'] = maybe_serialize($info['info']);
		$result = $wpdb->insert(
			$this->table_name,
			$info
		);
		if( !$result ) {
			return false;
		}
		return $wpdb->insert_id;
	}
	public function update( $info ) {
	 	global $wpdb;
	 	$table_name = $this->table_name;
	 	// Value Serialize
	 	$cast = maybe_serialize($cast);

	 	// Update or Add
	    $update = $wpdb->get_row(
	 		$wpdb->prepare( "SELECT id FROM $table_name WHERE name = %s LIMIT 1", $info['name'] )
	 	);
	 	if( $update ) {
		 	$info['info'] = maybe_serialize($info['info']);
	 		$result = $wpdb->update($table_name, $info, array('name'=>$info['name']));
 			return $update->id;
		}else {
		 	$info['info'] = maybe_serialize($info['info']);
		    $inserted = $this->add($info);
		    return $inserted;
		}
		return true;
	}
	public function check() {
	    if ( get_site_option( 'PeopleInfo_version' ) != $this->PeopleInfo_dbversion ) {
	        $this->create();
	    }
	}
}
add_action("after_switch_theme", array((new PeopleInfoDB), "create"));
add_action( 'plugins_loaded', array((new PeopleInfoDB), "check") );