<?
class MembersDB {
	function __construct() {
		global $wpdb;
		$this->wpdb = $wpdb;
		$this->Members_dbversion = '1.0';
		$this->table_name = 'Members';
	}
	public function create() {
		global $wpdb;
		$charset_collate = $wpdb->get_charset_collate();
		$table_name = $this->table_name;

		$sql = "CREATE TABLE $table_name (
			id bigint(20) NOT NULL AUTO_INCREMENT,
			groupID bigint(20) NOT NULL,
			user longtext NOT NULL,
			date longtext NOT NULL,
			PRIMARY KEY  (id)
		) $charset_collate;";

		require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
		dbDelta( $sql );

		update_option( 'Members_version', $this->Members_dbversion );
	}
	public function query( $userID, $per=10, $offset=0 ) {
	 	global $wpdb;
	 	$table_name = $this->table_name;
	 	$row = $wpdb->get_results(
	 		$wpdb->prepare( "SELECT DISTINCT groupID FROM $table_name WHERE user = %s ORDER BY CAST(date AS int) DESC LIMIT $offset,$per", $groupID )
	 	);
	 	if( !$row ) {
	 		return false;
	 	}else {
	 		$groups = $row;
		}
		return $groups;
	}
	public function get( $groupID, $per=10, $offset=0 ) {
	 	global $wpdb;
	 	$table_name = $this->table_name;
	 	$row = $wpdb->get_results(
	 		$wpdb->prepare( "SELECT DISTINCT * FROM $table_name WHERE groupID = %s ORDER BY CAST(date AS int) DESC LIMIT $offset,$per", $groupID )
	 	);
	 	if( !$row ) {
	 		return false;
	 	}else {
	 		$members = $row;
		}
		return $members;
	}
	public function count( $groupID ) {
	 	global $wpdb;
	 	$table_name = $this->table_name;
	 	$Operator = "SELECT COUNT(groupID) AS count FROM `$table_name` WHERE `groupID` = $groupID";
	 	$sqloper = $wpdb->get_row($Operator);
	 	//
		return $sqloper->count;
	}
	public function userIN( $memberID, $groupID ) {
	 	global $wpdb;
	 	$table_name = $this->table_name;
	 	$row = $wpdb->get_results(
	 		$wpdb->prepare( "SELECT DISTINCT * FROM $table_name WHERE groupID = %s AND user = $memberID", $groupID )
	 	);
	 	if( !$row ) {
	 		return false;
	 	}else {
	 		$members = $row;
		}
		return $members;
	}
	public function add( $info=array() ) {
	 	global $wpdb;
	 	$info['date'] = time();
	 	$table_name = $this->table_name;
		$result = $wpdb->insert(
			$this->table_name,
			$info
		);
		if( !$result ) {
			return false;
		}
		return $wpdb->insert_id;
	}
	public function delete( $info=array() ) {
	 	global $wpdb;
	 	$table_name = $this->table_name;
		$result = $wpdb->delete(
			$this->table_name,
			$info
		);
		return true;
	}
	public function check() {
	    if ( get_site_option( 'Members_version' ) != $this->Members_dbversion ) {
	        $this->create();
	    }
	}
}
add_action("after_switch_theme", array((new MembersDB), "create"));
add_action( 'plugins_loaded', array((new MembersDB), "check") );