<?
class MessagesDB {
	function __construct() {
		global $wpdb;
		$this->wpdb = $wpdb;
		$this->Messages_dbversion = '1.1';
		$this->table_name = 'Messages';
	}
	public function create() {
		global $wpdb;
		$charset_collate = $wpdb->get_charset_collate();
		$table_name = $this->table_name;

		$sql = "CREATE TABLE $table_name (
			id bigint(20) NOT NULL AUTO_INCREMENT,
			chatID longtext NOT NULL,
			sender longtext NOT NULL,
			message longtext NOT NULL,
			options longtext NOT NULL,
			parent longtext NOT NULL,
			reaction longtext NOT NULL,
			date longtext NOT NULL,
			PRIMARY KEY  (id)
		) $charset_collate;";

		require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
		dbDelta( $sql );

		update_option( 'Messages_version', $this->Messages_dbversion );
	}
	public function check() {
	    if ( get_site_option( 'Messages_version' ) != $this->Messages_dbversion ) {
	        $this->create();
	    }
	}
	public function delete( $where=array() ) {
	 	global $wpdb;
	 	$table_name = $this->table_name;

 		$wpdb->delete($table_name, $where);
	}
	public function message( $id ) {
		global $wpdb;
	 	$table_name = $this->table_name;
	 	$Operator = "SELECT * FROM `$table_name` WHERE `id` = '$id'";
	 	$message = $wpdb->get_row($Operator);
	 	//
	 	if( empty($message) ) {
	 		$message = false;
	 	}else {
	 		$message = $message;
	 	}
	 	return $message;
	}
	public function messages( $chatID, $offset=0, $per=20, $reverse=true ) {
		global $wpdb;
	 	$table_name = $this->table_name;
	 	$Operator = "SELECT * FROM `$table_name` WHERE `chatID` = '$chatID' AND `parent` = '0' AND `sender` != 'divider' ORDER BY CAST(date AS int) DESC LIMIT $offset, $per";
	 	$messages = $wpdb->get_results($Operator);
	 	//
	 	if( empty($messages) ) {
	 		$messages = false;
	 	}else if( $reverse == true ){
	 		$messages = array_reverse($messages);
	 	}
	 	return $messages;
	}
	public function globe_messages( $chatID, $offset=0, $per=20, $reverse=true ) {
		global $wpdb;
	 	$table_name = $this->table_name;
	 	$Operator = "SELECT * FROM `$table_name` WHERE `chatID` = '$chatID' AND `sender` != 'divider' ORDER BY CAST(date AS int) DESC LIMIT $offset, $per";
	 	$messages = $wpdb->get_results($Operator);
	 	//
	 	if( empty($messages) ) {
	 		$messages = false;
	 	}else if( $reverse == true ){
	 		$messages = array_reverse($messages);
	 	}
	 	return $messages;
	}
	public function parents( $parent ) {
		global $wpdb;
	 	$table_name = $this->table_name;
	 	$Operator = "SELECT * FROM `$table_name` WHERE `parent` = '$parent' ORDER BY CAST(date AS int) DESC";
	 	$messages = $wpdb->get_results($Operator);
	 	//
	 	if( empty($messages) ) {
	 		$messages = false;
	 	}else {
	 		$messages = array_reverse($messages);
	 	}
	 	return $messages;
	}
	public function getmsg( $id, $chat ) {
		global $wpdb;
	 	$table_name = $this->table_name;
	 	$Operator = "SELECT * FROM `$table_name` WHERE `chatID` = '$chat' and `id` = '$id'";
	 	$messages = $wpdb->get_row($Operator);
	 	//
	 	return $messages;
	}
	public function add( $info=array() ) {
	 	global $wpdb;
 		$info['message'] = stripslashes($info['message']);
 		$info['date'] = time();
	 	if( !isset($info['reaction']) )
	 		$info['reaction'] = array();
	 	if( isset($info['reaction']) )
	 		$info['reaction'] = maybe_serialize($info['reaction']);
	 	if( isset($info['options']) )
	 		$info['options'] = maybe_serialize($info['options']);
	 	$table_name = $this->table_name;
		$result = $wpdb->insert(
			$this->table_name,
			$info
		);
		if( !$result ) {
			return false;
		}
		return $wpdb->insert_id;
	}
	public function update( $info=array(), $where=array() ) {
	 	global $wpdb;
	 	if( !isset($info['reaction']) )
	 		$info['reaction'] = array();
	 	if( isset($info['reaction']) )
	 		$info['reaction'] = maybe_serialize($info['reaction']);
	 	if( isset($info['options']) )
	 		$info['options'] = maybe_serialize($info['options']);
	 	$table_name = $this->table_name;
		$result = $wpdb->update(
			$this->table_name,
			$info,
			$where
		);
		if( !$result ) {
			return false;
		}
		return true;
	}
}
add_action("after_switch_theme", array((new MessagesDB), "create"));
add_action( 'plugins_loaded', array((new MessagesDB), "check") );