<?
class PhotosDB {
	function __construct() {
		global $wpdb;
		$this->wpdb = $wpdb;
		$this->Photos_dbversion = '1.1';
		$this->table_name = 'Photos';
	}
	public function create() {
		global $wpdb;
		$charset_collate = $wpdb->get_charset_collate();
		$table_name = $this->table_name;

		$sql = "CREATE TABLE $table_name (
			id bigint(20) NOT NULL AUTO_INCREMENT,
			uid longtext NOT NULL,
			type text NOT NULL,
			url longtext NOT NULL,
			path longtext NOT NULL,
			date longtext NOT NULL,
			PRIMARY KEY  (id)
		) $charset_collate;";

		require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
		dbDelta( $sql );

		update_option( 'Photos_version', $this->Photos_dbversion );
	}
	public function check() {
	    if ( get_site_option( 'Photos_version' ) != $this->Photos_dbversion ) {
	        $this->create();
	    }
	}
	public function add( $info=array() ) {
	 	global $wpdb;
	 	if( !isset($info['uid']) or empty($info['uid']) )
	 		return false;
	 	$info['date'] = time();
	 	$table_name = $this->table_name;
		$result = $wpdb->insert(
			$this->table_name,
			$info
		);
		if( !$result ) {
			return false;
		}
		return $wpdb->insert_id;
	}
	public function query( $args=array() ) {
		if( !isset($args['per']) ) {
			$per = 6;
		}else {
			$per = $args['per'];
			unset($args['per']);
		}
		if( !isset($args['offset']) ) {
			$offset = 0;
		}else {
			$offset = $args['offset'];
			unset($args['offset']);
		}
	 	global $wpdb;
	 	$table_name = $this->table_name;
	 	$Operator = "SELECT * FROM `$table_name`";
	 	$WHERE = ' WHERE';
	 	$AND = ' AND';
	 	$i = 0;
	 	foreach ($args as $k => $v) {
	 		if( is_numeric($v) ) {
	 			$v = "$v";
	 		}else {
	 			$v = "'$v'";
	 		}
	 		if( $i == 0 ) {
		 		$Operator .= "$WHERE $k = $v";
		 	}else {
		 		$Operator .= "$AND $k = $v";
		 	}
	 	$i++;}
	 	$Operator .= " ORDER BY CAST(date AS int) DESC LIMIT $offset,$per";
	 	$result = $wpdb->get_results($Operator);
		return $result;
	}
	public function get( $id ) {
	 	global $wpdb;
	 	$table_name = $this->table_name;
	 	$row = $wpdb->get_row(
	 		$wpdb->prepare( "SELECT DISTINCT * FROM $table_name WHERE id = %s", $id )
	 	);
	 	if( !$row ) {
	 		return false;
	 	}else {
	 		$result = maybe_unserialize($row);
		}
		return $result;
	}
	public function delete( $where=array() ) {
	 	global $wpdb;
	 	$table_name = $this->table_name;

 		$wpdb->delete($table_name, $where);
	}
}
add_action("after_switch_theme", array((new PhotosDB), "create"));
add_action( 'plugins_loaded', array((new PhotosDB), "check") );