<?
class TX_actor {
	function __construct() {
		global $wpdb;
		$this->wpdb = $wpdb;
		$this->TX_actor_dbversion = '1.2';
		$this->table_name = 'TX_actor';
	}
	public function create() {
		global $wpdb;
		$charset_collate = $wpdb->get_charset_collate();
		$table_name = $this->table_name;

		$sql = "CREATE TABLE $table_name (
			id bigint(20) NOT NULL AUTO_INCREMENT,
			name longtext NOT NULL,
			about longtext NOT NULL,
			slug longtext NOT NULL,
			description longtext NOT NULL,
			photo longtext NOT NULL,
			thumb longtext NOT NULL,
			trademark longtext NOT NULL,
			selary longtext NOT NULL,
			nickname longtext NOT NULL,
			arname longtext NOT NULL,
			birthName longtext NOT NULL,
			date DATE NOT NULL,
			location longtext NOT NULL,
			height longtext NOT NULL,
			rate longtext NOT NULL,
			views bigint(80) NOT NULL,
			PRIMARY KEY (id)
		) $charset_collate;";

		require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
		dbDelta( $sql );

		update_option( 'TX_actor_version', $this->TX_actor_dbversion );
	}
	public function get( $name, $field='name', $select='*' ) {
		return $this->where($field, $name, $select);
	}
	public function query( $orderby='views', $number=40, $offset=0 ) {
	 	global $wpdb;
	 	$table_name = $this->table_name;
	 	$row = $wpdb->get_results(
	 		$wpdb->prepare( "SELECT DISTINCT * FROM $table_name ORDER BY `$table_name`.`views` DESC LIMIT $offset, $number", $orderby )
	 	);
	 	if( !$row ) {
	 		return false;
	 	}else {
	 		$value = $row;
	 	}
		return $value;
	}
	public function where( $field, $val, $select ) {
	 	global $wpdb;
	 	$table_name = $this->table_name;
	 	$row = $wpdb->get_row(
	 		$wpdb->prepare( "SELECT DISTINCT $select FROM $table_name WHERE $field = %s LIMIT 1", $val )
	 	);
	 	if( !$row ) {
	 		return false;
	 	}else {
	 		$value = maybe_unserialize($row);
	 	}
		return $value;
	}
	public function add( $slug, $arr ) {
		$array = array();
		foreach ($arr as $k => $v) {
			$v = maybe_serialize($v);
			$array[$k] = $v;
		}
	 	global $wpdb;
		$result = $wpdb->insert($this->table_name, $array);
		if( !$result ) {
			return false;
		}
		return $this->get($array['slug'], 'slug')->id;
	}
	public function updateViews($slug, $views) {
	 	global $wpdb;
	 	$table_name = $this->table_name;
		$result = $wpdb->update($table_name, array('views'=>$views), array('slug'=>$slug));
		return true;
	}
	public function updateRate($slug, $rate) {
	 	global $wpdb;
	 	$table_name = $this->table_name;
		$result = $wpdb->update($table_name, array('rate'=>$rate), array('slug'=>$slug));
		return true;
	}
	public function delete( $id ) {
	 	global $wpdb;
	 	$table_name = $this->table_name;
 		$wpdb->delete($table_name, array('id'=>$id));
 		return true;
	}
	public function update( $slug, $arr=array() ) {
	 	global $wpdb;
	 	$table_name = $this->table_name;
	 	if( empty($arr) ) return false;
	 	$value = maybe_serialize($value);
	 	// Update or Add
	    $update = $this->get($slug, 'slug');
	 	if( isset($update->name) ) {
			$array = array();
			foreach ($arr as $k => $v) {
				$v = maybe_serialize($v);
				$array[$k] = $v;
			}
	 		$result = $wpdb->update($table_name, $array, array('slug'=>$slug));
	 		if( !$result ){
	 			return false;
	 		}
		}else {
		    $this->add($slug, $arr);
		}
		return true;
	}
	public function check() {
	    if ( get_site_option( 'TX_actor_version' ) != $this->TX_actor_dbversion ) {
	        $this->create();
	    }
	}
}