<?
class UppomSizes {
	function __construct() {
		global $wpdb;
		$this->wpdb = $wpdb;
		$this->UppomSizes_dbversion = '1.0';
		$this->table_name = 'UppomSizes';
	}
	public function create() {
		global $wpdb;
		$charset_collate = $wpdb->get_charset_collate();
		$table_name = $this->table_name;

		$sql = "CREATE TABLE $table_name (
			id bigint(20) NOT NULL AUTO_INCREMENT,
			url longtext NOT NULL,
			size longtext NOT NULL,
			PRIMARY KEY  (id)
		) $charset_collate;";

		require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
		dbDelta( $sql );

		update_option( 'UppomSizes_version', $this->UppomSizes_dbversion );
	}
	public function get( $url ) {
	 	global $wpdb;
	 	$table_name = $this->table_name;
	 	$row = $wpdb->get_row(
	 		$wpdb->prepare( "SELECT DISTINCT size FROM $table_name WHERE url = %s LIMIT 1", $url )
	 	);
	 	if( !$row ) {
	 		return false;
	 	}else {
	 		$data = maybe_unserialize($row->size);
	 	}
		return $data;
	}
	public function add( $url, $size ) {
	 	global $wpdb;
		$result = $wpdb->insert(
			$this->table_name,
			array(
			    'url' => $url,
			    'size' => $size,
			)
		);
		if( !$result ) {
			return false;
		}
		return true;
	}
	public function update( $url, $size ) {
	 	global $wpdb;
	 	$table_name = $this->table_name;
	 	// Value Serialize

	 	// Update or Add
	    $update = $this->get($url);
	 	if( $update ) {
	 		$result = $wpdb->update($table_name, array('size'=>$size), array('url'=>$url));
	 		if( !$result ){
	 			return false;
	 		}
		}else {
		    $this->add($url, $size);
		}
		return true;
	}
	public function check() {
	    if ( get_site_option( 'UppomSizes_version' ) != $this->UppomSizes_dbversion ) {
	        $this->create();
	    }
	}
}